"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.promise");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _checkStatus = _interopRequireDefault(require("../util/checkStatus"));

module.exports = function getRetryInterceptor(fetch, request, option) {
  //retry count
  var retryCount = option.retryCount; //timeout

  var retryTimeout = option.retryTimeout;

  var retry = function retry() {
    return fetch(request).then(_checkStatus.default).catch(function (error) {
      return onRejected(error);
    });
  };

  var retryAdapter = function retryAdapter() {
    if (retryTimeout && retryTimeout > 0) {
      return (
        /*#__PURE__*/
        (0, _asyncToGenerator2.default)(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee() {
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return timeout(retryTimeout);

                case 2:
                  return _context.abrupt("return", retry());

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }))
      );
    } else {
      return retry;
    }
  }; //get retry function


  var retryFunction = retryAdapter();

  var onFulfilled = function onFulfilled(result) {
    return result;
  };

  var onRejected =
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2(error) {
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(retryCount >= 1)) {
                _context2.next = 5;
                break;
              }

              retryCount--;
              return _context2.abrupt("return", retryFunction());

            case 5:
              return _context2.abrupt("return", Promise.reject(error));

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function onRejected(_x) {
      return _ref2.apply(this, arguments);
    };
  }();

  return [onFulfilled, onRejected];
};

function timeout(timeout) {
  return new Promise(function (resolve) {
    setTimeout(resolve, timeout);
  });
}