"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.regexp.replace");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.assign");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _interceptor = _interopRequireDefault(require("./interceptor"));

var _transformResponse = _interopRequireDefault(require("../util/transformResponse"));

var _transformRequest = _interopRequireDefault(require("../util/transformRequest"));

var _checkStatus = _interopRequireDefault(require("../util/checkStatus"));

var _timeout = _interopRequireDefault(require("./timeout"));

var _promiseTask = _interopRequireDefault(require("./promiseTask"));

var _buildSearchParams = _interopRequireDefault(require("../util/buildSearchParams"));

var _typeCheck = require("../util/typeCheck");

var _baseUrl = require("../util/baseUrl");

var _normalizeHeaderName = _interopRequireDefault(require("../util/normalizeHeaderName"));

var _retry = _interopRequireDefault(require("./retry"));

var zyFetch =
/*#__PURE__*/
function () {
  function zyFetch(config, fetch) {
    (0, _classCallCheck2.default)(this, zyFetch);
    this.config = config;
    this.nativeFetch = fetch;
    this.interceptors = {
      request: new _interceptor.default(),
      response: {
        transform: new _interceptor.default(),
        noTransform: new _interceptor.default()
      }
    };
  }

  (0, _createClass2.default)(zyFetch, [{
    key: "send",
    value: function send(init) {
      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var config = {}; // merge config

      Object.assign(config, this.config, option);

      var request = this._getRequest(init, config);

      var promiseTask = new _promiseTask.default();

      this._initPromiseTask(promiseTask, config, request);

      return promiseTask.execute(request);
    }
  }, {
    key: "get",
    value: function get(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: "delete",
    value: function _delete(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: "options",
    value: function options(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: "head",
    value: function head(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: "post",
    value: function post(init, body, option) {
      option = this._methodsOptionMerge(option, 'post', body);
      return this.send(init, option);
    }
  }, {
    key: "put",
    value: function put(init, body, option) {
      option = this._methodsOptionMerge(option, 'put', body);
      return this.send(init, option);
    }
  }, {
    key: "patch",
    value: function patch(init, body, option) {
      option = this._methodsOptionMerge(option, 'patch', body);
      return this.send(init, option);
    }
    /**
     *
     * @param fetchs some fetch
     * @returns {Promise.<*[]>} return promise
     */

  }, {
    key: "all",
    value: function all(fetchs) {
      return Promise.all(fetchs);
    }
    /**
     * Execute fetch in sequence
     * @param fetchs some fetch
     */

  }, {
    key: "allByOrder",
    value: function () {
      var _allByOrder = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(fetchs) {
        var responseArray, i, response;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                responseArray = [];
                i = 0;

              case 2:
                if (!(i < fetchs.length)) {
                  _context.next = 10;
                  break;
                }

                _context.next = 5;
                return fetchs[i].call(this);

              case 5:
                response = _context.sent;
                responseArray.push(response);

              case 7:
                i++;
                _context.next = 2;
                break;

              case 10:
                return _context.abrupt("return", Promise.resolve(responseArray));

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function allByOrder(_x) {
        return _allByOrder.apply(this, arguments);
      };
    }()
    /**
     * 将函数的数组参数解构 [1,2,3] => 1,2,3
     * @param cb
     * @returns {Function}
     */

  }, {
    key: "spread",
    value: function spread(cb) {
      return function (args) {
        return cb.apply(null, args);
      };
    }
  }, {
    key: "_initPromiseTask",
    value: function _initPromiseTask(promiseTask, config, request) {
      var interceptors = this.interceptors; // set request promise

      interceptors.request.forEach(function (interceptor) {
        promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
      });
      var fetch; //set timeout

      if (config.timeout && config.timeout > 0) {
        fetch = (0, _timeout.default)(this.nativeFetch, config.timeout);
        promiseTask.add(fetch);
      } else {
        fetch = this.nativeFetch;
        promiseTask.add(fetch);
      } //set checkStatus promise


      promiseTask.add(_checkStatus.default); //set retry

      if (config.retry && config.retry > 1) {
        promiseTask.add.apply(promiseTask, (0, _toConsumableArray2.default)((0, _retry.default)(fetch, request, {
          'retryCount': config.retry,
          'retryTimeout': config.retryTimeout
        })));
      } //set before transform response interceptors promise


      interceptors.response.noTransform.forEach(function (interceptor) {
        promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
      }); //set transform response promise

      if (config.transformResponse) {
        promiseTask.add(_transformResponse.default.bind(this, config.responseType)); // set after transform response promise

        interceptors.response.transform.forEach(function (interceptor) {
          promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
        });
      }
    }
  }, {
    key: "_methodsOptionMerge",
    value: function _methodsOptionMerge() {
      var option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var method = arguments.length > 1 ? arguments[1] : undefined;
      var body = arguments.length > 2 ? arguments[2] : undefined;
      Object.assign(option, {
        method: method,
        body: body
      });
      return option;
    }
  }, {
    key: "_getRequest",
    value: function _getRequest(init, config) {
      (0, _normalizeHeaderName.default)(config.headers, 'Content-Type'); //handle body

      config.body = config.transformRequest && config.body ? (0, _transformRequest.default)(config.body, config.headers) : config.body;
      var isRequest = init instanceof Request; //handle url

      var isNeedMerge = false;
      var url = isRequest ? init.url : init;

      if (config.baseUrl && !(0, _baseUrl.isAbsoluteURL)(url)) {
        url = (0, _baseUrl.buildAbsoluteURL)(config.baseUrl, url);
        isNeedMerge = true;
      } // like //www.github.com -> https://www.github.com


      if (/^\/\//.test(url)) {
        url = url.replace(/(?=^\/\/)/, 'https:');
        isNeedMerge = true;
      }

      if (config.params) {
        url = (0, _buildSearchParams.default)(url, config.params);
        isNeedMerge = true;
      }

      if (isRequest) {
        if (isNeedMerge) {
          return this._mergeRequest(url, init, config);
        } else {
          return new Request(init, config);
        }
      }

      return new Request(url, config);
    }
  }, {
    key: "_mergeRequest",
    value: function _mergeRequest(url, request, config) {
      var copyRequest = {}; //copy request props, but body can not get, so request.body will be ignore

      for (var key in request) {
        var val = request[key];

        if (!(0, _typeCheck.isFunction)(val)) {
          copyRequest[key] = val;
        }
      }

      Object.assign(copyRequest, config);
      return new Request(url, copyRequest);
    }
  }]);
  return zyFetch;
}();

module.exports = zyFetch;