"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.function.name");

require("core-js/modules/web.dom.iterable");

var _zyFetch = _interopRequireDefault(require("./core/zyFetch"));

var _config = _interopRequireDefault(require("./core/config"));

var _nativeFetch = _interopRequireDefault(require("./fetch/nativeFetch"));

var _extend = require("./util/extend");

var nativeFetch = (0, _nativeFetch.default)();

function createInstance(option) {
  var zy = new _zyFetch.default(option, nativeFetch);
  var instance = proxy(zy.send, zy);

  function proxy(fn, thisArgs) {
    return function (init, option) {
      return fn.call(thisArgs, init, option);
    };
  } // extend method


  Object.getOwnPropertyNames(_zyFetch.default.prototype).forEach(function (name) {
    instance[name] = zy[name];
  }); // extend own  prop

  Object.getOwnPropertyNames(zy).forEach(function (name) {
    instance[name] = zy[name];
  });
  return instance;
}

var zyFetch = createInstance((0, _extend.deepCopy)(_config.default));

zyFetch.create = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var option = (0, _extend.deepCopy)(_config.default);
  Object.assign(option, config);
  return createInstance(option);
};

module.exports = zyFetch; //for TypeScript.

exports.default = zyFetch;